#include "GestorRanking.h"
#include <iostream>

GestorRanking::GestorRanking()
{
	
}

void GestorRanking::getRanking(list<Puntuacion> &ranking)
{
	ifstream *fe = new ifstream("ranking.r",ios::in);

	if (fe->is_open())
	{
		leerFichero(ranking,fe);
		fe->close();
		delete fe;
	}
	else
	{
		delete fe;
		ofstream *fs = new ofstream("ranking.r",ios::out); 
		if (fs->is_open())
		{
			for (int i=0; i<10; i++)
			{
				Puntuacion puntuacion;
				puntuacion.nombre = "AAA";
				puntuacion.puntos = 0;
				ranking.push_back(puntuacion);
			}

			escribirFichero(ranking,fs);

			fs->close();
			delete fs;
		}

		else
		{
			cout <<endl<<"No se ha podido crear el fichero de rankings"<<endl;
		}
	}
}

void GestorRanking::setRanking(list<Puntuacion> &ranking, Puntuacion &puntuacion)
{
	ofstream *fs = new ofstream("ranking.r",ios::out); 

	if (fs->is_open())
	{
		ranking.push_back(puntuacion);

		ranking.sort(compararPuntos);

		ranking.pop_back();

		escribirFichero(ranking,fs);

		fs->close();
	}
	else
	{
		cout <<endl<<"No se ha podido escribir el fichero de rankings"<<endl;
	}
	delete fs;
}

void GestorRanking::leerFichero(list<Puntuacion> &ranking, ifstream *fe)
{
	for(int i=0; i<10; i++)
	{
		Puntuacion puntuacion;
		
		string nombre="";
		string entrada="";
		int puntos;
	
		*fe >> entrada;
		nombre+=entrada;
	  	while (entrada!="_SEP_")
		{
			*fe >> entrada;
			if (entrada!="_SEP_")
				nombre+=entrada;
		}

		*fe >> puntos;

		puntuacion.nombre=nombre;
		puntuacion.puntos=puntos;

		ranking.push_back(puntuacion);
	}	
}

void GestorRanking::escribirFichero(list<Puntuacion> &ranking, ofstream *fs)
{
	list<Puntuacion>::iterator it = ranking.begin();

	while( it != ranking.end() )
	{
	  	*fs << (*it).nombre;
		*fs << " _SEP_ " ;
		*fs << (*it).puntos;
		*fs << " ";
		
		*it++;
	}
}

bool GestorRanking::compararPuntos(Puntuacion p1, Puntuacion p2)
{
	return p1.puntos>p2.puntos;
}
